/*
**
**  MBTALK
**
**  (c) 1997 mike warren
**  mikeBot
**
**  sends random insults, parses MBL- commands. see 
**
**   http://www.ucalgary.ca/~mbwarren/mikeBot/ 
**
**  for more on the mikeBotLanguage (MBL-)
**
*/



#include "mbtalk.h"

/*
**  ctor : initialize variables
**
*/

mbtalk::mbtalk()
{
	cooperating=0;
}

/*
**  update : SKELTON FUNCTION
**
*/

void mbtalk::update()
{
	char temp[ 100 ];

  if( cooperating )
    {
      if( players[ cooperating ].hate >= 0 )
	{
	  sprintf(temp,"say %s: you blew it...no more cooperate\n", players[cooperating].name );
	  sendConsole( temp );
	  pants( opts.get( "default-pants" ) );
	  shirt( opts.get( "default-shirt" ) );
	  players[ cooperating ].hate = 1000;
	  cooperating=0;
	}
    }
  
 }


/*
**  parseMessage : looks for mblanguage strings in say messages
**
*/

void mbtalk::parseMessage( char * x )
{
  static char buff[ Q_MAX_STRING ];
  static char buff2[ Q_MAX_STRING ];
  char * name, * message;
  char * command=0;
  int i,k, playerNumber;

  if( x[0] != 1 )		// not a "say" message
    return;

  strcpy( buff, &x[1] );

  name = strtok( buff, ":" );
  message = strtok( NULL, " \t\n\0" );

  i=0;
  while( message && message[i] )
    {
      if( !strncmp( &message[i], "mbl-", 4 ))
	command = strtok( &message[i+4], " \t\n\0" );
      i++;
    }

  parseName( (unsigned char *)name );

  playerNumber=-1;

  for( i=0; i < info.maxPlayers; i++ )
    if( players[i].name && !strcmp( name, players[i].name ) )
      {
	playerNumber=i;
	break;
      }

  if( command )
    {
      if( !opts.get("no-print-mbl") )
		printf("mbtalk::parseMessage(): from %d:%s `%s'\n", playerNumber, name, command );

      if( playerNumber != (myEntityNumber-1) )
	{

      if( !strcmp( "author", command ) )
	{
	  sendConsole( "say \"author: mike warren " );
	  sendConsole( "say \"www.ucalgary.ca/~mbwarren/mikeBot/");
	  sendConsole( "say \"mbwarren@acs.ucalgary.ca ");
	}
      else if ( !strcmp( "cooperate", command ) )
	{
	  if( players[ playerNumber ].hate < 900 && !cooperating)
	    {
	      sprintf( buff2, "say \"%s: yes-mbl-cooperate ", name);
	      sendConsole( buff2 );
	      players[ playerNumber ].hate = -200;
	      pants( players[ playerNumber ].pants );
	      shirt( players[ playerNumber ].shirt );
	      cooperating = playerNumber;
	    }
	  else
	    {
	      sprintf( buff2, "say \"%s: no-mbl-cooperate ", name);
	      sendConsole( buff2 );
	    }
	}
      else if ( !strcmp( "maximal-hate", command ) )
	{
	  sprintf( buff2, "say \"%s: yes-mbl-maximal-hate ", name );
	  sendConsole( buff2 );
	  players[ playerNumber ].hate = 500;
	}
      else if ( !strcmp( "hate", command ) )
	{
	  k=0;
	  for( i=0; i < info.maxPlayers; i++ )
	    {
	      if( players[i].hate > k )
		k=players[i].hate;
	    }
	  sprintf( buff2, "say \"%s: %8.2f%% (%d of %d) ", name, 100.0*((float)players[playerNumber].hate / (float)k), players[playerNumber].hate, k );
	  sendConsole( buff2 );
	}
      else if ( !strcmp( "bot", command ) )
	{
	  sprintf( buff2, "say \"%s: mbl-bot-mikeBot\n", players[playerNumber].name);
	  sendConsole( buff2 );
	}
      else if ( !strcmp( "socket", command ) )
	{
	  sprintf( buff2, "say \"%s: mbl-socket-no\n",players[playerNumber].name );
	  sendConsole( buff2 );
	}
      else if ( !strcmp( "compliance", command ) )
	{
	  sprintf( buff2, "say \"%s: mbl-compliance-level-2\n", players[playerNumber].name);
	  sendConsole( buff2 );
	}
      else if ( !strcmp( "help", command ) )
	{
	  sendConsole( "say \"mbl-author:contact info");
	  sendConsole( "say \"mbl-cooperate:be on team");
	  sendConsole( "say \"mbl-hate:your hate level");
	  sendConsole( "say \"mbl-maximal-hate:higher hate");
	  sendConsole( "say \"mbl-target:my target");
	  sendConsole( "say \"mbl-observers:connected observers");
	  sendConsole( "say \"connect to my IP to watch...");
	}
      else if ( !strcmp( "target", command ) )
	{
	  sprintf( buff2, "say \"target : %s", mbf_target?players[mbf_target-1].name:"none." );
	  sendConsole( buff2 );
	}
      else if ( !strcmp( "observers", command ) )
	{
#if QPROXY
	  if( proxy )
	    {
	      sprintf( buff2, "say \"observers %d : ", proxy->connected());
	      for( i=0; i < QX_MAX_CLIENTS; i++ )
		{
		  strcat( buff2, proxy->getClientName( i ) );
		  strcat( buff2, ", " );
		}
	      sendConsole( buff2 );
	    }
	  else
	    sendConsole(" say\"observers: none.");
#else
	  sendConsole("say \"observers: none.");
#endif
	}
      else
	{
	  sprintf( buff2, "say \"%s: unknown: %s ", name, command );
	  sendConsole( buff2 );
	}
    }
    }
  message = x;
  i=0;
  while( message[i] != ':' )
    if( ++i >= Q_MAX_STRING ) 
      break;

  if( i < Q_MAX_STRING )
    if( !strncmp( &message[i], ": no bots", 9 ) || 
       !strncmp( &message[i], ": humans only", 13 ) || 
       !strncmp( &message[i], ": bots suck", 11 ) )
      {
	sprintf( buff2, "say \"%s: i am autonomous...\n", players[playerNumber].name );
	sendConsole( buff2 );
      }
}
